#ifndef _DECL_reduction_H_
#define _DECL_reduction_H_
#include "charm++.h"
#ifdef CMK_CHECK_CRC
extern "C" void checkAllCRC(int);
#endif
/* DECLS: array reductionArray: ArrayElement{
reductionArray(CkMigrateMessage* impl_msg);
reductionArray(void);
void start(void);
};
 */
 class reductionArray;
 class CkIndex_reductionArray;
 class CProxy_reductionArray;
 class CProxyElement_reductionArray;
 class CProxySection_reductionArray;
/* --------------- index object ------------------ */
class CkIndex_reductionArray:public CProxyElement_ArrayElement{
  public:
    typedef reductionArray local_t;
    typedef CkIndex_reductionArray index_t;
    typedef CProxy_reductionArray proxy_t;
    typedef CProxyElement_reductionArray element_t;
    typedef CProxySection_reductionArray section_t;

    static int __idx;
    static void __register(const char *s, size_t size);
/* DECLS: reductionArray(CkMigrateMessage* impl_msg);
 */
    static int __idx_reductionArray_CkMigrateMessage;
    static int ckNew(CkMigrateMessage* impl_msg) { return __idx_reductionArray_CkMigrateMessage; }
    static void _call_reductionArray_CkMigrateMessage(void* impl_msg,reductionArray* impl_obj);

/* DECLS: reductionArray(void);
 */
    static int __idx_reductionArray_void;
    static int ckNew(void) { return __idx_reductionArray_void; }
    static void _call_reductionArray_void(void* impl_msg,reductionArray* impl_obj);

/* DECLS: void start(void);
 */
    static int __idx_start_void;
    static int start(void) { return __idx_start_void; }
    static void _call_start_void(void* impl_msg,reductionArray* impl_obj);
};
/* --------------- element proxy ------------------ */
 class CProxyElement_reductionArray : public CProxyElement_ArrayElement{
  public:
    typedef reductionArray local_t;
    typedef CkIndex_reductionArray index_t;
    typedef CProxy_reductionArray proxy_t;
    typedef CProxyElement_reductionArray element_t;
    typedef CProxySection_reductionArray section_t;

    CProxyElement_reductionArray(void) {}
    CProxyElement_reductionArray(const ArrayElement *e) : CProxyElement_ArrayElement(e){  }
    void ckDelegate(CkDelegateMgr *dTo,CkDelegateData *dPtr=NULL) {
      CProxyElement_ArrayElement::ckDelegate(dTo,dPtr);
    }
    void ckUndelegate(void) {
      CProxyElement_ArrayElement::ckUndelegate();
    }
    void pup(PUP::er &p) {
      CProxyElement_ArrayElement::pup(p);
    }
    CK_DISAMBIG_ARRAY_ELEMENT(CProxyElement_ArrayElement)
    reductionArray *ckLocal(void) const
      { return (reductionArray *)CProxyElement_ArrayElement::ckLocal(); }
    CProxyElement_reductionArray(const CkArrayID &aid,const CkArrayIndex1D &idx,CK_DELCTOR_PARAM)
        :CProxyElement_ArrayElement(aid,idx,CK_DELCTOR_ARGS) {}
    CProxyElement_reductionArray(const CkArrayID &aid,const CkArrayIndex1D &idx)
        :CProxyElement_ArrayElement(aid,idx) {}
/* DECLS: reductionArray(CkMigrateMessage* impl_msg);
 */

/* DECLS: reductionArray(void);
 */
    void insert(int onPE=-1);
/* DECLS: void start(void);
 */
    void start(void) ;
};
PUPmarshall(CProxyElement_reductionArray);
/* ---------------- collective proxy -------------- */
 class CProxy_reductionArray : public CProxy_ArrayElement{
  public:
    typedef reductionArray local_t;
    typedef CkIndex_reductionArray index_t;
    typedef CProxy_reductionArray proxy_t;
    typedef CProxyElement_reductionArray element_t;
    typedef CProxySection_reductionArray section_t;

    CProxy_reductionArray(void) {}
    CProxy_reductionArray(const ArrayElement *e) : CProxy_ArrayElement(e){  }
    void ckDelegate(CkDelegateMgr *dTo,CkDelegateData *dPtr=NULL) {
      CProxy_ArrayElement::ckDelegate(dTo,dPtr);
    }
    void ckUndelegate(void) {
      CProxy_ArrayElement::ckUndelegate();
    }
    void pup(PUP::er &p) {
      CProxy_ArrayElement::pup(p);
    }
    CK_DISAMBIG_ARRAY(CProxy_ArrayElement)
    static CkArrayID ckNew(void) {return ckCreateEmptyArray();}
//Generalized array indexing:
    CProxyElement_reductionArray operator [] (const CkArrayIndex1D &idx) const
        {return CProxyElement_reductionArray(ckGetArrayID(), idx, CK_DELCTOR_CALL);}
    CProxyElement_reductionArray operator() (const CkArrayIndex1D &idx) const
        {return CProxyElement_reductionArray(ckGetArrayID(), idx, CK_DELCTOR_CALL);}
    CProxyElement_reductionArray operator [] (int idx) const 
        {return CProxyElement_reductionArray(ckGetArrayID(), CkArrayIndex1D(idx), CK_DELCTOR_CALL);}
    CProxyElement_reductionArray operator () (int idx) const 
        {return CProxyElement_reductionArray(ckGetArrayID(), CkArrayIndex1D(idx), CK_DELCTOR_CALL);}
    CProxy_reductionArray(const CkArrayID &aid,CK_DELCTOR_PARAM) 
        :CProxy_ArrayElement(aid,CK_DELCTOR_ARGS) {}
    CProxy_reductionArray(const CkArrayID &aid) 
        :CProxy_ArrayElement(aid) {}
/* DECLS: reductionArray(CkMigrateMessage* impl_msg);
 */

/* DECLS: reductionArray(void);
 */
    static CkArrayID ckNew(const CkArrayOptions &opts);
    static CkArrayID ckNew(const int s1);

/* DECLS: void start(void);
 */
    void start(void) ;
};
PUPmarshall(CProxy_reductionArray);
/* ---------------- section proxy -------------- */
 class CProxySection_reductionArray : public CProxySection_ArrayElement{
  public:
    typedef reductionArray local_t;
    typedef CkIndex_reductionArray index_t;
    typedef CProxy_reductionArray proxy_t;
    typedef CProxyElement_reductionArray element_t;
    typedef CProxySection_reductionArray section_t;

    CProxySection_reductionArray(void) {}
    void ckDelegate(CkDelegateMgr *dTo,CkDelegateData *dPtr=NULL) {
      CProxySection_ArrayElement::ckDelegate(dTo,dPtr);
    }
    void ckUndelegate(void) {
      CProxySection_ArrayElement::ckUndelegate();
    }
    void pup(PUP::er &p) {
      CProxySection_ArrayElement::pup(p);
    }
    CK_DISAMBIG_ARRAY_SECTION(CProxySection_ArrayElement)
//Generalized array indexing:
    CProxyElement_reductionArray operator [] (const CkArrayIndex1D &idx) const
        {return CProxyElement_reductionArray(ckGetArrayID(), idx, CK_DELCTOR_CALL);}
    CProxyElement_reductionArray operator() (const CkArrayIndex1D &idx) const
        {return CProxyElement_reductionArray(ckGetArrayID(), idx, CK_DELCTOR_CALL);}
    CProxyElement_reductionArray operator [] (int idx) const 
        {return CProxyElement_reductionArray(ckGetArrayID(), *(CkArrayIndex1D*)&ckGetArrayElements()[idx], CK_DELCTOR_CALL);}
    CProxyElement_reductionArray operator () (int idx) const 
        {return CProxyElement_reductionArray(ckGetArrayID(), *(CkArrayIndex1D*)&ckGetArrayElements()[idx], CK_DELCTOR_CALL);}
    static CkSectionID ckNew(const CkArrayID &aid, CkArrayIndex1D *elems, int nElems) {
      return CkSectionID(aid, elems, nElems);
    } 
    static CkSectionID ckNew(const CkArrayID &aid, int l, int u, int s) {
      CkVec<CkArrayIndex1D> al;
      for (int i=l; i<=u; i+=s) al.push_back(CkArrayIndex1D(i));
      return CkSectionID(aid, al.getVec(), al.size());
    } 
    CProxySection_reductionArray(const CkArrayID &aid, CkArrayIndexMax *elems, int nElems, CK_DELCTOR_PARAM) 
        :CProxySection_ArrayElement(aid,elems,nElems,CK_DELCTOR_ARGS) {}
    CProxySection_reductionArray(const CkArrayID &aid, CkArrayIndexMax *elems, int nElems) 
        :CProxySection_ArrayElement(aid,elems,nElems) {}
    CProxySection_reductionArray(const CkSectionID &sid)       :CProxySection_ArrayElement(sid) {}
    static CkSectionID ckNew(const CkArrayID &aid, CkArrayIndexMax *elems, int nElems) {
      return CkSectionID(aid, elems, nElems);
    } 
/* DECLS: reductionArray(CkMigrateMessage* impl_msg);
 */

/* DECLS: reductionArray(void);
 */

/* DECLS: void start(void);
 */
    void start(void) ;
};
PUPmarshall(CProxySection_reductionArray);
typedef CBaseT<ArrayElementT<CkIndex1D>,CProxy_reductionArray>  CBase_reductionArray;

/* DECLS: group reductionGroup: IrrGroup{
reductionGroup(void);
void start(void);
};
 */
 class reductionGroup;
 class CkIndex_reductionGroup;
 class CProxy_reductionGroup;
 class CProxyElement_reductionGroup;
/* --------------- index object ------------------ */
class CkIndex_reductionGroup:public CProxyElement_IrrGroup{
  public:
    typedef reductionGroup local_t;
    typedef CkIndex_reductionGroup index_t;
    typedef CProxy_reductionGroup proxy_t;
    typedef CProxyElement_reductionGroup element_t;

    static int __idx;
    static void __register(const char *s, size_t size);
/* DECLS: reductionGroup(void);
 */
    static int __idx_reductionGroup_void;
    static int ckNew(void) { return __idx_reductionGroup_void; }
    static void _call_reductionGroup_void(void* impl_msg,reductionGroup* impl_obj);

/* DECLS: void start(void);
 */
    static int __idx_start_void;
    static int start(void) { return __idx_start_void; }
    static void _call_start_void(void* impl_msg,reductionGroup* impl_obj);
};
/* --------------- element proxy ------------------ */
class CProxyElement_reductionGroup: public CProxyElement_IrrGroup{
  public:
    typedef reductionGroup local_t;
    typedef CkIndex_reductionGroup index_t;
    typedef CProxy_reductionGroup proxy_t;
    typedef CProxyElement_reductionGroup element_t;

    CProxyElement_reductionGroup(void) {}
    CProxyElement_reductionGroup(const IrrGroup *g) : CProxyElement_IrrGroup(g){  }
    CProxyElement_reductionGroup(CkGroupID _gid,int _onPE,CK_DELCTOR_PARAM) : CProxyElement_IrrGroup(_gid,_onPE,CK_DELCTOR_ARGS){  }
    CProxyElement_reductionGroup(CkGroupID _gid,int _onPE) : CProxyElement_IrrGroup(_gid,_onPE){  }
   CK_DISAMBIG_GROUP_ELEMENT(CProxyElement_IrrGroup)
    void ckDelegate(CkDelegateMgr *dTo,CkDelegateData *dPtr=NULL) {
      CProxyElement_IrrGroup::ckDelegate(dTo,dPtr);
    }
    void ckUndelegate(void) {
      CProxyElement_IrrGroup::ckUndelegate();
    }
    void pup(PUP::er &p) {
      CProxyElement_IrrGroup::pup(p);
    }
    void ckSetGroupID(CkGroupID g) {
      CProxyElement_IrrGroup::ckSetGroupID(g);
    }
    reductionGroup* ckLocalBranch(void) const {
      return ckLocalBranch(ckGetGroupID());
    }
    static reductionGroup* ckLocalBranch(CkGroupID gID) {
      return (reductionGroup*)CkLocalBranch(gID);
    }
/* DECLS: reductionGroup(void);
 */

/* DECLS: void start(void);
 */
    void start(void);
};
PUPmarshall(CProxyElement_reductionGroup);
/* ---------------- collective proxy -------------- */
class CProxy_reductionGroup: public CProxy_IrrGroup{
  public:
    typedef reductionGroup local_t;
    typedef CkIndex_reductionGroup index_t;
    typedef CProxy_reductionGroup proxy_t;
    typedef CProxyElement_reductionGroup element_t;

    CProxy_reductionGroup(void) {}
    CProxy_reductionGroup(const IrrGroup *g) : CProxy_IrrGroup(g){  }
    CProxy_reductionGroup(CkGroupID _gid,CK_DELCTOR_PARAM) : CProxy_IrrGroup(_gid,CK_DELCTOR_ARGS){  }
    CProxy_reductionGroup(CkGroupID _gid) : CProxy_IrrGroup(_gid){  }
    CProxyElement_reductionGroup operator[](int onPE) const
      {return CProxyElement_reductionGroup(ckGetGroupID(),onPE,CK_DELCTOR_CALL);}
   CK_DISAMBIG_GROUP(CProxy_IrrGroup)
    void ckDelegate(CkDelegateMgr *dTo,CkDelegateData *dPtr=NULL) {
      CProxy_IrrGroup::ckDelegate(dTo,dPtr);
    }
    void ckUndelegate(void) {
      CProxy_IrrGroup::ckUndelegate();
    }
    void pup(PUP::er &p) {
      CProxy_IrrGroup::pup(p);
    }
    void ckSetGroupID(CkGroupID g) {
      CProxy_IrrGroup::ckSetGroupID(g);
    }
    reductionGroup* ckLocalBranch(void) const {
      return ckLocalBranch(ckGetGroupID());
    }
    static reductionGroup* ckLocalBranch(CkGroupID gID) {
      return (reductionGroup*)CkLocalBranch(gID);
    }
/* DECLS: reductionGroup(void);
 */
    static CkGroupID ckNew(void);

/* DECLS: void start(void);
 */
    void start(void);
    void start(int npes, int *pes);
};
PUPmarshall(CProxy_reductionGroup);
typedef CBaseT<Group,CProxy_reductionGroup>  CBase_reductionGroup;

extern void _registerreduction(void);
#endif
